import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Calculator extends JFrame implements ActionListener  {

    public static void main (String [] args) {
	Calculator calculator = new Calculator();
        calculator.setVisible(true);

    }

    // private instance variables
    JTextField line;
    String expression;
    int index;
    int len;
 
    /**
     * Constructor for objects of class Calculator
     */
    public Calculator() {
        setTitle ("Simple Text Calculator");
        setSize (240, 80);
        setDefaultCloseOperation( EXIT_ON_CLOSE );
        // get the content pane and set properties
        Container contentPane = getContentPane();
        contentPane.setLayout(null); // so that we can use absolute positioning
        line = new JTextField();
        line.setBounds(10,10,200,20);
        line.addActionListener(this);
        contentPane.add(line);
    }

    public  void actionPerformed (ActionEvent ae) {
	int operand1;
	char operator;
	int operand2;
        int result;
        final String LEGAL_EXPRESSION = ".*";

	index = 0;
        expression = line.getText();

        // Ignore this statement until you get to Checkpoint 7
        if (expression == "q") {
            System.exit(0);
        }

        // Ignore this statement until you get to Checkpoint 5
        if (!expression.matches(LEGAL_EXPRESSION)) {
 	    line.setText("Error in expression");
	    return;
        }

	len = expression.length();

	operand1 = getOperand();
	operator = getOperator();
	operand2 = getOperand();

        if (operator == '+')
	    result = operand1 + operand2;
        else if (operator == '-')
	    result = operand1 - operand2;
        else if (operator == '*')
	    result = operand1 * operand2;
        else 
	    result = operand1 / operand2;

        line.setText(formatExpression(expression)+"="+Integer.toString(result));
    }

    // Ignore this method until you get to Checkpoint 6
    private String formatExpression(String exp) {
	return exp;
    }

    private boolean isDigit(char c) {
	return (c >= '0' && c <= '9');
    }

    private int getOperand() {
	int beginIdx;
	int endIdx;

	while (index < len && expression.charAt(index) == ' ')
	    index++;
	beginIdx = index;

	while (index < len && isDigit(expression.charAt(index)))
	    index++;
	endIdx = index;

	return Integer.parseInt(expression.substring(beginIdx,endIdx));
    }

    private char getOperator() {
	char operator;

	operator = expression.charAt(index);
	index++;
	return operator;
    }
}
