import javax.swing.*;
import java.awt.*;


public class GraphPaper extends JFrame  {

    // class constants
    private static final int FRAME_SIZE = 600;
    private static final int NUM_SQUARES = 10;
    private static final int SQUARE_SIZE = FRAME_SIZE/NUM_SQUARES;

    // private instance variables
    private Point [] [] graphPoints;

    public static void main (String [] args)  {

        GraphPaper gp = new GraphPaper();
    }
	
    public GraphPaper() {

   	super("Graph Paper");
        setSize(FRAME_SIZE, FRAME_SIZE);
        setVisible(true);
        graphPoints =    
           new Point [NUM_SQUARES+1][NUM_SQUARES+1];

       for (int r = 0; r < graphPoints.length; r++)
         for (int c = 0; c < graphPoints[r].length; c++)
             graphPoints[r][c] = 
		 new Point (c*SQUARE_SIZE, r*SQUARE_SIZE);
    }

 
    public void paint (Graphics g) {   

       // Draw the lines!
       for (int r = 0; r < graphPoints.length; r++)
	   for (int c = 0; c < graphPoints[r].length-1; c++) {
               Point p = graphPoints[r][c];
               Point q = graphPoints[r][c+1];
	       g.drawLine(p.x, p.y, q.x, q.y);
	   }
       for (int c = 0; c < graphPoints.length; c++)
	   for (int r = 0; r < graphPoints[c].length-1; r++) {
               Point p = graphPoints[r][c];
               Point q = graphPoints[r+1][c];
	       g.drawLine(p.x, p.y, q.x, q.y);
	   }
    }
}
