import java.io.*;

public class Demo {
    private static int MAX_SIZE = 2000;
    private static int MAX_VALUE = MAX_SIZE;

    public static void main (String [] args) throws IOException {
        String name = args[0];
        BufferedReader inStream = new BufferedReader (
                     		        new FileReader(
                             		  new File (name)));
        int [] data = new int [MAX_SIZE];
        
    	for (int i = 0; i < data.length; i++ ) {
            String s = inStream.readLine();
            data[i] = Integer.parseInt(s);
    	}
        inStream.close();

        System.out.println("Sorting data....");        
      	selectionSort (data);
        //bubbleSort(data);
        //insertionSort(data);
        //heapSort(data);

        PrintWriter outStream = new PrintWriter (
                     		     new FileOutputStream(
                             		  new File ("sorted.txt")));
        
     	for (int i = 0; i < data.length; i++ ) {
            outStream.println(data[i]);
	    }
        outStream.close();
    }

    public static void selectionSort (int [] numbers) {

      int comparisons = 0;
      for (int startIndex = 0; startIndex <= numbers.length - 2; startIndex++){
         
          int minIndex = startIndex;
          for (int i = startIndex+1; i <= numbers.length-1; i++) {
              if (numbers[i] < numbers[minIndex])
		          minIndex = i;
              comparisons++;
          }
          int temp = numbers[startIndex];
          numbers[startIndex] = numbers[minIndex];
          numbers[minIndex] = temp;
      }
      System.out.println ("selectionSort: " + comparisons + " comparisons made");
    }

    public static void bubbleSort (int [] numbers) {

        int comparisons = 0;        
        int bottom = numbers.length - 2;
        boolean exchanged = true;

        while (exchanged) {
            exchanged = false;
           
            for (int i = 0; i <= bottom; i++) {
                comparisons++;
       		    if (numbers[i] > numbers[i+1]) {
               	    int temp = numbers[i];
                    numbers[i] = numbers[i+1];
                    numbers[i+1] = temp;
                    exchanged = true;
                }
            }
            bottom--;
        }
      System.out.println ("bubbleSort: " + comparisons + " comparisons made");
    }


    public static void insertionSort (int [] numbers) {

        int comparisons = 0;
        
        for (int i = 1; i < numbers.length ; i++) {
            comparisons++;
            if (numbers[i] < numbers[i-1]) {
		        int temp = numbers[i];
                int j = i;           
                do {
		            numbers[j] = numbers[j-1];
                    j--;
                    if (j > 0)
                       comparisons++;
		        } while (j > 0 && numbers[j-1] > temp);
                numbers[j] = temp;
            }
	    }
         System.out.println ("insertionSort: " + comparisons + " comparisons made");
        
    }

    public static void heapSort (int [] numbers) {
	Heap heap = new Heap();
        heap.setData(numbers);
        numbers = heap.sort();

        System.out.println ("heapSort: " + heap.comparisons + " comparisons made");
    }
}



